package com.perforce.hive.connection;

import java.util.ArrayList;
import java.util.List;

import com.perforce.p4java.admin.IProtectionEntry;
import com.perforce.p4java.core.IReviewSubscription;
import com.perforce.p4java.core.IUser;
import com.perforce.p4java.core.ViewMap;
import com.perforce.p4java.exception.P4JavaException;
import com.perforce.p4java.server.IOptionsServer;

public class AccountModel {

	private final IUser account;
	private final List<String> reviews;
	private final List<IProtectionEntry> protects;

	public AccountModel(IOptionsServer p4) throws P4JavaException {
		String user = p4.getUserName();
		account = p4.getUser(user);

		reviews = new ArrayList<>();
		ViewMap<IReviewSubscription> sub = account.getReviewSubscriptions();
		if (sub != null) {
			for (IReviewSubscription r : sub) {
				reviews.add(r.getSubscription());
			}
		}

		protects = p4.getProtectionEntries(null, null);
	}

	public IUser getUser() {
		return account;
	}

	public List<IProtectionEntry> getProtects() {
		return protects;
	}

	public List<String> getReviews() {
		return reviews;
	}
}
